Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.json
Class JSONTokener

    java.lang.Object
      org.json.JSONTokener

    public class JSONTokener

extends java.lang.Object

A JSONTokener takes a source string and extracts characters and tokens from it. It is used by the JSONObject and JSONArray constructors to parse JSON source strings.

Version:
  2010-02-02
Author:
  JSON.org

Field Summary
`private int` | `character`
`private boolean` | `eof`
`private int` | `index`
`private int` | `line`
`private char` | `previous`
`private java.io.Reader` | `reader`
`private boolean` | `usePrevious`

Constructor Summary
`JSONTokener(java.io.Reader reader)` Construct a JSONTokener from a reader.
`JSONTokener(java.lang.String s)` Construct a JSONTokener from a string.

Method Summary
`void` | `back()` Back up one character.
`static int` | `dehexchar(char c)` Get the hex value of a character (base16).
`boolean` | `end()`
`boolean` | `more()` Determine if the source string still contains characters that next() can consume.
`char` | `next()` Get the next character in the source string.
`char` | `next(char c)` Consume the next character, and check that it matches a specified character.
`java.lang.String` | `next(int n)` Get the next n characters.
`char` | `nextClean()` Get the next char in the string, skipping whitespace.
`java.lang.String` | `nextString(char quote)` Return the characters up to the next close quote character.
`java.lang.String` | `nextTo(char d)` Get the text up but not including the specified character or the end of line, whichever comes first.
`java.lang.String` | `nextTo(java.lang.String delimiters)` Get the text up but not including one of the specified delimiter characters or the end of line, whichever comes first.
`java.lang.Object` | `nextValue()` Get the next value.
`char` | `skipTo(char to)` Skip characters until the next character is the requested character.
`JSONException` | `syntaxError(java.lang.String message)` Make a JSONException to signal a syntax error.
`java.lang.String` | `toString()` Make a printable string of this JSONTokener.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### character

    private int character

### eof

    private boolean eof

### index

    private int index

### line

    private int line

### previous

    private char previous

### reader

    private java.io.Reader reader

### usePrevious

    private boolean usePrevious

Constructor Detail

### JSONTokener

    public JSONTokener(java.io.Reader reader)

  Construct a JSONTokener from a reader.

  Parameters:
    `reader` - A reader.

### JSONTokener

    public JSONTokener(java.lang.String s)

  Construct a JSONTokener from a string.

  Parameters:
    `s` - A source string.

Method Detail

### back

    public void back()
              throws JSONException

  Back up one character. This provides a sort of lookahead capability, so that you can test for a digit or letter before attempting to parse the next number or identifier.

  Throws:
    `JSONException`

### dehexchar

    public static int dehexchar(char c)

  Get the hex value of a character (base16).

  Parameters:
    `c` - A character between '0' and '9' or between 'A' and 'F' or between 'a' and 'f'.
  Returns:
    An int between 0 and 15, or -1 if c was not a hex digit.

### end

    public boolean end()

### more

    public boolean more()
                 throws JSONException

  Determine if the source string still contains characters that next() can consume.

  Returns:
    true if not yet at the end of the source.
  Throws:
    `JSONException`

### next

    public char next()
              throws JSONException

  Get the next character in the source string.

  Returns:
    The next character, or 0 if past the end of the source string.
  Throws:
    `JSONException`

### next

    public char next(char c)
              throws JSONException

  Consume the next character, and check that it matches a specified character.

  Parameters:
    `c` - The character to match.
  Returns:
    The character.
  Throws:
    `JSONException` - if the character does not match.

### next

    public java.lang.String next(int n)
                          throws JSONException

  Get the next n characters.

  Parameters:
    `n` - The number of characters to take.
  Returns:
    A string of n characters.
  Throws:
    `JSONException` - Substring bounds error if there are not n characters remaining in the source string.

### nextClean

    public char nextClean()
                   throws JSONException

  Get the next char in the string, skipping whitespace.

  Returns:
    A character, or 0 if there are no more characters.
  Throws:
    `JSONException`

### nextString

    public java.lang.String nextString(char quote)
                                throws JSONException

  Return the characters up to the next close quote character. Backslash processing is done. The formal JSON format does not allow strings in single quotes, but an implementation is allowed to accept them.

  Parameters:
    `quote` - The quoting character, either `"` (double quote) or `'` (single quote).
  Returns:
    A String.
  Throws:
    `JSONException` - Unterminated string.

### nextTo

    public java.lang.String nextTo(char d)
                            throws JSONException

  Get the text up but not including the specified character or the end of line, whichever comes first.

  Parameters:
    `d` - A delimiter character.
  Returns:
    A string.
  Throws:
    `JSONException`

### nextTo

    public java.lang.String nextTo(java.lang.String delimiters)
                            throws JSONException

  Get the text up but not including one of the specified delimiter characters or the end of line, whichever comes first.

  Parameters:
    `delimiters` - A set of delimiter characters.
  Returns:
    A string, trimmed.
  Throws:
    `JSONException`

### nextValue

    public java.lang.Object nextValue()
                               throws JSONException

  Get the next value. The value can be a Boolean, Double, Integer, JSONArray, JSONObject, Long, or String, or the JSONObject.NULL object.

  Returns:
    An object.
  Throws:
    `JSONException` - If syntax error.

### skipTo

    public char skipTo(char to)
                throws JSONException

  Skip characters until the next character is the requested character. If the requested character is not found, no characters are skipped.

  Parameters:
    `to` - A character to skip to.
  Returns:
    The requested character, or zero if the requested character is not found.
  Throws:
    `JSONException`

### syntaxError

    public JSONException syntaxError(java.lang.String message)

  Make a JSONException to signal a syntax error.

  Parameters:
    `message` - The error message.
  Returns:
    A JSONException object, suitable for throwing

### toString

    public java.lang.String toString()

  Make a printable string of this JSONTokener.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    " at {index} [character {character} line {line}]"

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD